; ------------------------------
; THE improved 'ARCTAN' FUNCTION
; ------------------------------
; (Offset $21: 'atn')
;   The inverse tangent function with the result in radians.
;   This is a fundamental transcendental function from which others such as asn
;   and acs are directly, or indirectly, derived.
;   It uses the series generator to produce Chebyshev polynomials.
;
fn_atn
	LD A,(HL)		; fetch exponent
	CP $81			; compare to that for 'one'
	JR C,SMALL		; forward, if less, to SMALL

	RST 28H		;; FP-CALC		X.
	DEFB $A1	;;stk-one		X, 1.
	DEFB $18	;;negate		X, -1.
	DEFB $01	;;exchange		-1, X.
	DEFB $05	;;division		-1/X.
	DEFB $2D	;;duplicate		-1/X, -1/X.

;;-	DEFB $32	;;less-0
;;-	DEFB $A3	;;stk-pi/2
;;-	DEFB $01	;;exchange

	.db $A3		;;stk-pi/2		-1/X, -1/X, PI/2.
	.db $01		;;exchange		-1/X, PI/2, -1/X.

	.db $32		;;less-0		-1/X, PI/2, (1/0).
	DEFB $00	;;jump-true
	DEFB CASES-$	;;to CASES		-1/X, PI/2.

	DEFB $18	;;negate		-1/X, -PI/2.
	DEFB $2F	;;jump
	DEFB CASES-$	;;to CASES
; ---
;
SMALL
	RST 28H		;; FP-CALC
	DEFB $A0	;;stk-zero
CASES
	DEFB $01	;;exchange

;;-	DEFB $2D	;;duplicate
;;-	DEFB $2D	;;duplicate
;;-	DEFB $04	;;multiply

	.db $3D		;;stk-square		x, x*x.

;;-	DEFB $2D	;;duplicate
;;-	DEFB $0F	;;addition

	.db $3A		;;mul-by-2		x, 2*x*x

;;-	DEFB $A1	;;stk-one
;;-	DEFB $03	;;subtract

	.db $39		;;sub-one macro		x, 2*x*x-1

	DEFB $8C	;;series-0C
	DEFB $10	;;Exponent: $60, Bytes: 1
	DEFB $B2	;;(+00,+00,+00)
	DEFB $13	;;Exponent: $63, Bytes: 1
	DEFB $0E	;;(+00,+00,+00)
	DEFB $55	;;Exponent: $65, Bytes: 2
	DEFB $E4,$8D	;;(+00,+00)
	DEFB $58	;;Exponent: $68, Bytes: 2
	DEFB $39,$BC	;;(+00,+00)
	DEFB $5B	;;Exponent: $6B, Bytes: 2
	DEFB $98,$FD	;;(+00,+00)
	DEFB $9E	;;Exponent: $6E, Bytes: 3
	DEFB $00,$36,$75 ;;(+00)
	DEFB $A0	;;Exponent: $70, Bytes: 3
	DEFB $DB,$E8,$B4 ;;(+00)
	DEFB $63	;;Exponent: $73, Bytes: 2
	DEFB $42,$C4	;;(+00,+00)
	DEFB $E6	;;Exponent: $76, Bytes: 4
	DEFB $B5,$09,$36,$BE ;;
	DEFB $E9	;;Exponent: $79, Bytes: 4
	DEFB $36,$73,$1B,$5D ;;
	DEFB $EC	;;Exponent: $7C, Bytes: 4
	DEFB $D8,$DE,$63,$BE ;;
	DEFB $F0	;;Exponent: $80, Bytes: 4
	DEFB $61,$A1,$B3,$0C ;;

	DEFB $04	;;multiply
	DEFB $0F	;;addition
	DEFB $34	;;end-calc

	RET			; return.
