; -----------------------------------
; THE improved 'EXPONENTIAL' FUNCTION
; -----------------------------------
; (Offset $23: 'exp')
;   The exponential function returns the exponential of the argument, or the
;   value of 'e' (2.7182818...) raised to the power of the argument.
;   PRINT EXP 1 gives 2.7182818
;
;   EXP is the opposite of the LN function (see below) and is equivalent to 
;   the 'antiln' function found on pocket calculators or the 'Inverse ln'
;   function found on the Windows scientific calculator.
;   So PRINT EXP LN 5.3 will give 5.3 as will PRINT LN EXP 5.3 or indeed
;   any number e.g. PRINT EXP LN PI.
;
;   The applications of the exponential function are in areas where exponential
;   growth is experienced, calculus, population growth and compound interest.
;
;   Error 6 if the argument is above 88.
;
fn_exp
	RST 28H		;; FP-CALC
	DEFB $30	;;stk-data			1/LN 2
	DEFB $F1	;;Exponent: $81, Bytes: 4
	DEFB $38,$AA,$3B,$29 ;;
	DEFB $04	;;multiply
	DEFB $2D	;;duplicate
	DEFB $24	;;int
	DEFB $C3	;;st-mem-3
	DEFB $03	;;subtract

;;-	DEFB $2D	;;duplicate
;;-	DEFB $0F	;;addition

	.db $3A		;;mul-by-2		2*x

;;-	DEFB $A1	;;stk-one
;;-	DEFB $03	;;subtract

	.db $39		;;sub-one macro

	DEFB $88	;;series-08
	DEFB $13	;;Exponent: $63, Bytes: 1
	DEFB $36	;;(+00,+00,+00)
	DEFB $58	;;Exponent: $68, Bytes: 2
	DEFB $65,$66	;;(+00,+00)
	DEFB $9D	;;Exponent: $6D, Bytes: 3
	DEFB $78,$65,$40 ;;(+00)
	DEFB $A2	;;Exponent: $72, Bytes: 3
	DEFB $60,$32,$C9 ;;(+00)
	DEFB $E7	;;Exponent: $77, Bytes: 4
	DEFB $21,$F7,$AF,$24 ;;
	DEFB $EB	;;Exponent: $7B, Bytes: 4
	DEFB $2F,$B0,$B0,$14 ;;
	DEFB $EE	;;Exponent: $7E, Bytes: 4
	DEFB $7E,$BB,$94,$58 ;;
	DEFB $F1	;;Exponent: $81, Bytes: 4
	DEFB $3A,$7E,$F8,$CF ;;

	DEFB $E3	;;get-mem-3
	DEFB $34	;;end-calc

	CALL FP_TO_A		; routine FP-TO-A
	JR NZ,N_NEGTV		; to N-NEGTV

	JR C,REPORT_6b		; to REPORT-6b

	ADD A,(HL)		;
	JR NC,RESULT_OK		; to RESULT-OK
;
REPORT_6b
	RST 08H			; ERROR-1
	DEFB $05		; Error Report: Number too big
;
N_NEGTV
	JR C,RSLT_ZERO		; to RSLT-ZERO

	SUB (HL)		;
	JR NC,RSLT_ZERO		; to RSLT-ZERO

	NEG			; Negate
;
RESULT_OK
	LD (HL),A		;
	RET			; return.
;
RSLT_ZERO
;;-	RST 28H		;; FP-CALC
;;-	DEFB $02	;;delete
;;-	DEFB $A0	;;stk-zero
;;-	DEFB $34	;;end-calc

;;-	RET			; return.

	and a			; clear CY and return via
	jp FP_0_1		; FP-0/1 to replace last value with zero
