; ---------------------------------------------------------
; THE improved 'INTEGER TRUNCATION TOWARDS ZERO' SUBROUTINE
; ---------------------------------------------------------
; (offset $36: 'truncate')
truncate			; (L18E4)
	LD A,(HL)		; fetch exponent

;;-	CP $81			; compare to +1  
;;-	JR NC,L18EF		; forward, if 1 or more, to T-GR-ZERO
;;-
;;- else the number is smaller than plus or minus 1 and can be made zero.
;;-
;;-	LD (HL),$00		; make exponent zero.
;;-	LD A,$20		; prepare to set 32 bits of mantissa to zero.
;;-	JR L18F4		; forward to NIL-BYTES
; ---
;
;;- T-GR-ZERO
;;- L18EF:
;;-	SUB $A0			; subtract +32 from exponent
;;-	RET P			; return if result is positive as all 32 bits 
				; of the mantissa relate to the integer part.
				; The floating point is somewhere to the right 
				; of the mantissa

;;-	NEG			; else negate to form number of rightmost bits 
				; to be blanked.

	add a,$7F		; if abs(number)<1		 (eponent<$81)	
	jp nc,FP_0_1		; then return with zero			(CY=0)

	cp $1F			; return if all 32 bits of the mantissa
	ret nc			; relate to the integer part.	 (eponent>$9f)

	cpl			; else form number of rightmost bits 
	add a,$20		; to be blanked.
;
; for instance, disregarding the sign bit, the number 3.5 is held as 
; exponent $82 mantissa .11100000 00000000 00000000 00000000
;
;;- we need to set $82 - $A0 = $E2 NEG = $1E (thirty) bits to zero to form the 
;;- integer.
;;- The sign of the number is never considered as the first bit of the mantissa
;;- must be part of the integer.
;
; we need to set $82+$7F=$01, CPL=$FE, $FE+$20=$1E (thirty) bits to zero 
; to form the integer. The sign of the number is never considered as the
; first bit of the mantissa must be part of the integer.

;;- NIL-BYTES
;;-L18F4:
	PUSH DE			; save pointer to STKEND
	EX DE,HL		; HL points at STKEND

;;-	DEC HL			; now at last byte of mantissa.
;;-	LD B,A			; Transfer bit count to B register.
;;-	SRL B			; divide by 
;;-	SRL B			; eight
;;-	SRL B			;
;;-	JR Z,L1905		; forward if zero to BITS-ZERO
;;-
;;- else the original count was eight or more and whole bytes can be blanked.
;;-
;;- BYTE-ZERO
;;- L1900:
;;-	LD (HL),$00		; set eight bits to zero.
;;-	DEC HL			; point to more significant byte of mantissa.
;;-	DJNZ L1900		; loop back to BYTE-ZERO
;
clr_byte
	dec hl			;
	sub $08			;
	jr c,clr_bits		;

	ld (hl),0		;
	jr clr_byte		;

; now consider any residual bits.
;
;;- BITS-ZERO
;;- L1905:
;;-	AND $07			; isolate the remaining bits
clr_bits
	add a,$08		; the remaining bits

	JR Z,L1912		; forward if none to IX-END

	LD B,A			; transfer bit count to B counter.
	LD A,$FF		; form a mask 11111111
;
;; LESS-MASK
L190C:	SLA A			; 1 <- 76543210 <- o	slide mask leftwards.
	DJNZ L190C		; loop back for bit count to LESS-MASK

	AND (HL)		; lose the unwanted rightmost bits
	LD (HL),A		; and place in mantissa byte.
;
;; IX-END
L1912:	EX DE,HL		; restore result pointer from DE. 
	POP DE			; restore STKEND from stack.
	RET 			; return.
