; -------------------------------------
; THE old 'INTEGER' FUNCTION (21 bytes)
; -------------------------------------
; (offset $24: 'int')
; This function returns the integer of x, which is just the same as truncate
; for positive numbers. The truncate literal truncates negative numbers
; upwards so that -3.4 gives -3 whereas the BASIC INT function has to
; truncate negative numbers down so that INT -3.4 is -4.
; It is best to work through using, say, plus and minus 3.4 as examples.
;
;;- int
;;-	RST 28H		;; FP-CALC		x.    (= 3.4 or -3.4).
;;-	DEFB $2D	;;duplicate		x, x.

;;-	DEFB $32	;;less-0		x, (1/0)
;;-	DEFB $00	;;jump-true		x, (1/0)
;;-	DEFB $04	;;to L1C46, X-NEG

;;-	DEFB $36	;;truncate		trunc 3.4 = 3.
;;-	DEFB $34	;;end-calc		3.

;;-	RET			; return with + int x on stack.

;;-X_NEG
;;-	DEFB $2D	;;duplicate		-3.4, -3.4.
;;-	DEFB $36	;;truncate		-3.4, -3.
;;-	DEFB $C0	;;st-mem-0		-3.4, -3.
;;-	DEFB $03	;;subtract		-.4
;;-	DEFB $E0	;;get-mem-0		-.4, -3.
;;-	DEFB $01	;;exchange		-3, -.4.

;;-	DEFB $2C	;;not			-3, (0).
;;-	DEFB $00	;;jump-true		-3.
;;-	DEFB $03	;;to L1C59, EXIT	-3.

;;-	DEFB $A1	;;stk-one		-3, 1.
;;-	DEFB $03	;;subtract		-4.

;;-EXIT
;;-	DEFB $34	;;end-calc		-4.

;;-	RET			; return.

;
; --------------------------
; THE new 'INTEGER' FUNCTION
; --------------------------
; (offset $24: 'int')
; This function returns the integer of x, which is just the same as truncate
; for positive numbers. The truncate literal truncates negative numbers
; upwards so that -3.4 gives -3 whereas the BASIC INT function has to
; truncate negative numbers down so that INT -3.4 is -4.
;
fn_int
	push hl			; save pointer to 'X'
	call COPY_FP		; duplicate

	ex de,hl		; DE now points the duplication
	ex (sp),hl		; HL now points 'X' again

	call truncate		; truncation towards zero

	ex de,hl		; HL now points the duplication
	pop de			; DE now points end of the duplication
	dec hl			; set pointer
	dec de			; set pointer

	ld b,4			; set counter
	xor a			; set Z flag
chck_int
	ld a,(de)		; fetch a byte of the duplication
	jr nz,skip_int		; skip if there was difference

	cp (hl)			; compare mantissa bytes
skip_int
	dec hl			; set pointer
	dec de			; set pointer
	djnz chck_int		;

	ret z			; return if it was an integer

	rla			; sign bit -> CY
	ret nc			; return if it was positive or zero
;				  else...
; ---------------------------
; THE 'SUBTRACT ONE' FUNCTION
; ---------------------------
; (Offset $39: 'sub-one')
; this part is a new 'macro', which replaces the next 2 calc. literals
;
;	$A1  :  stk-one
;	$03  :  subtract
;
sub_one
	push hl			; save pointer to 'X'

	ld a,$01		; stack 'ONE'
	call stk_con_x		;

	ex de,hl		; DE now points to 'ONE'
	pop hl			; HL points to 'X' again

	jp subtract		; return w. X=X-1
