; ---------------
; old Signum (26)
; ---------------
; This routine replaces the last value on the calculator stack,
; (which is in floating point form), with one if positive and with minus one
; if it is negative. If it is zero then it is left unchanged.
;
sgn	INC HL			; point to first byte of 4-byte mantissa.
	LD A,(HL)		; pick up the byte with the sign bit.
	DEC HL			; point to exponent.
	DEC (HL)		; test the exponent for
	INC (HL)		; the value zero.
	SCF			; Set the carry flag.
	CALL NZ,FP_0_1		; Routine FP-0/1  replaces last value with one
				; if exponent indicates the value is non-zero.
				; In either case mantissa is now four zeros.

	INC HL			; Point to first byte of 4-byte mantissa.
	RLCA			; Rotate original sign bit to carry.
	RR (HL)			; Rotate the carry into sign.
	DEC HL			; Point to last value.
	RET			; Return.
;
;	=====================================================================
;
; ---------------
; new Signum (26)
; ---------------
; This routine replaces the last value on the calculator stack,
; (which is in floating point form), with one if positive and with minus one
; if it is negative. If it is zero then it is left unchanged.
;
fn_sgn
	ld a,(hl)		; fetch exponent of last value on the stack
	and a			; test it.
	ret z			; return if zero.

	call greater1		; if >0 then CY=1 
	ret c			; and return value=1

	ld (hl),$81		; else make value 1
	jr negate_1		; and return via 'unary minus'
