;
; ---------------------------------
; THE patched 'PRINTING' SUBROUTINE
; ---------------------------------
;
;	.
;	.
;	.
;
;;- WRITE-N/L
;;-L0847:
;;-	LD C,$21		;
;;-	DEC B			;
;;-	SET 0,(IY+$01)		; sv FLAGS  - Suppress leading space
;;-	JP L0918		; to LOC-ADDR
;
;; WRITE-N/L
L0847:
	SET 0,(IY+$01)		; sv FLAGS  - Suppress leading space
loc_nxt0
	DEC B			;
loc_pos0
	LD C,$21		;
	JP L0918		; to LOC-ADDR

;
; =============================================================================
;
; --------------------------------------------
; THE patched 'POINTERS' SUBROUTINE (43 bytes)
; --------------------------------------------
;
;; POINTERS
;
;	.
;	.
;	.
;
;; -----------------------------------------------------
;; re-locate address - the end of the old SCROLL routine
;; -----------------------------------------------------
;
;;- reLocAdr
;;-	pop bc			; restore the saved position
;;-	inc b			; the last printable line
;;-	jr L0A4F		; springboard (-> routine LOC-ADDR)

	.db 0,0,0,0		; spare


;
; =============================================================================
;
; ----------------------------------
; THE patched 'LINE-ENDS' SUBROUTINE
; ----------------------------------
;
;; LINE-ENDS
L0A1F:	LD B,(IY+$22)		; sv DF_SZ
	PUSH BC			;
	CALL L0A2C		; routine B-LINES
	POP BC			;
;;-	DEC B			;
;;-	JR L0A2C		; to B-LINES

	jp loc_nxt0		; dec b -> ld c,$21 ==> retun via LOC-ADDR

;
; =============================================================================
;
; ------------------------------------------
; THE patched 'SCROLL' SUBROUTINE (27 bytes)
; ------------------------------------------
;
;; SCROLL
L0C0E:	LD B,(IY+$22)		; sv DF_SZ
;;-	LD C,$21		;
	push bc			; save line counter
;;-	CALL L0918		; routine LOC-ADDR
	call loc_pos0		; ld c,$21 --> LOC-ADDR
	
	dec hl			; insert a N/L before the N/L
	CALL L099B		; routine ONE-SPACE  

	LD HL,($400C)		; sv D_FILE_lo
	INC HL			;
	LD D,H			;
	LD E,L			;
	CPIR			;
	call L0A5D		; routine RECLAIM-1

;;-	jp reLocAdr		; set new S_POSN and DF_CC

	pop bc			; restore the saved position
	inc b			; the last printable line

	jp loc_pos0		; ld c,$21 --> LOC-ADDR
				; set new S_POSN and DF_CC
;
; =============================================================================
;
; --------------------------------
; THE patched 'IF' COMMAND ROUTINE
; --------------------------------
; In runtime, the class routines have evaluated the test expression and
; the result, true or false, is on the stack.
;
;; IF
L0DAB:	CALL L0DA6		; routine SYNTAX-Z
;;-	JR Z,L0DB6		; forward if checking syntax to IF-END
	jr z,if_end		; forward if checking syntax to IF-END
;
; else delete the Boolean value on the calculator stack.
;
;;-	RST 28H		;; FP-CALC
;;-	DEFB $02	;;delete
;;-	DEFB $34	;;end-calc

	call STK_FETCH		; routine STK-FETCH - exponent to A
				; mantissa to EDCB.
;;-
;;- register DE points to exponent of floating point value.
;;-
;;-	LD A,(DE)		; fetch exponent.
	AND A			; test for zero - FALSE.
	RET Z			; return if so.
;
;; IF-END (was L0DB6)
if_end
	JP L0CDE		; jump back to LINE-NULL
; ---
	.db $FF			; spare
;
; =============================================================================
;
; -------------------------------------
; THE 'DECREASE THE COUNTER' SUBROUTINE
; -------------------------------------
; (offset $31: 'dec-jr-nz')
; The calculator has an instruction that decrements a single-byte
; pseudo-register and makes consequential relative jumps just like
; the Z80's DJNZ instruction.
;
dec_jr_nz
	EXX			; switch in set that addresses code

	PUSH HL			; save pointer to offset byte
	LD HL,$401E		; address BREG in system variables
	DEC (HL)		; decrement it
	POP HL			; restore pointer
jmp_tru1
	JR NZ,JUMP_2		; to JUMP-2 if not zero

	INC HL			; step past the jump length.
	EXX			; switch in the main set.
	RET			; return.
;
; -------------------------------------
; THE patched 'JUMP ON TRUE' SUBROUTINE
; -------------------------------------
; (Offset $00; 'jump-true')
; This enables the calculator to perform conditional relative jumps
; dependent on whether the last test gave a true result
; On the ZX81, the exponent will be zero for zero or else $81 for one.
;
jump_true
	LD A,(DE)		; collect exponent byte
	AND A			; is result 0 or 1 ?
;;-	JR NZ,JUMP		; back to JUMP if true (1).

	EXX			; else switch in the pointer set.
;;-	INC HL			; step past the jump length.
;;-	EXX			; switch in the main set.
;;-	RET			; return.

	jr jmp_tru1		; back to JUMP if true (1).
;
; =============================================================================
;
; ----------------------------------
; THE patched 'SQUARE ROOT' FUNCTION
; ----------------------------------
; (Offset $25: 'sqr')
;   "If I have seen further, it is by standing on the shoulders of giants" -
;   Sir Isaac Newton, Cambridge 1676.
;   The sqr function has been re-written to use the Newton-Raphson method.
;   Joseph Raphson was a student of Sir Isaac Newton at Cambridge University
;   and helped publicize his work.
;   Although Newton's method is centuries old, this routine, appropriately, is 
;   based on a FORTH word written by Steven Vickers in the Jupiter Ace manual.
;   Whereas that method uses an initial guess of one, this one manipulates 
;   the exponent byte to obtain a better starting guess. 
;   First test for zero and return zero, if so, as the result.
;   If the argument is negative, then produce an error.
;
fn_sqr
	RST 28H		;; FP-CALC		x
	DEFB $C3	;;st-mem-3		x.   (seed for guess)
	DEFB $34	;;end-calc		x.
;
;   HL now points to exponent of argument on calculator stack.
;
;;-	LD A,(HL)		; Test for zero argument
;;-	AND A			; Test for zero argument
;;-	RET Z			; Return with zero on the calculator stack.
;
;   Test for a positive argument
;
	INC HL			; Address byte with sign bit.
	BIT 7,(HL)		; Test the bit.

	JR NZ,REPORT_A		; back to REPORT_A: 'Invalid argument'
;
;   This guess is based on a Usenet discussion.
;   Halve the exponent to achieve a good guess.(accurate with .25 16 64 etc.)
;
;;-	LD HL,$4071		; Address first byte of mem-3 (it is mem-4!!!)

	ld hl,$406C		; Address first byte of mem-3

	LD A,(HL)		; fetch exponent of mem-3

	and a			; Test for zero argument
	ret z			; Return with zero on the calculator stack.

;;-	XOR $80			; toggle sign of exponent of mem-3
;;-	SRA A			; shift right, bit 7 unchanged.
;;-	INC A			;
;;-	JR Z,ASIS		; forward with say .25 -> .5

;;-	JP P,ASIS		; leave increment if value > .5

;;-	DEC A			; restore to shift only.
;;- ASIS
;;-	XOR $80			; restore sign.

	sub $80			; remove the offset
	sra a			; halve the exponent
	add a,$81		; then set the offset (+1) again

	LD (HL),A		; and put back 'halved' exponent.
;
;   Now re-enter the calculator.
;
	RST   28H	;; FP-CALC		x
SLOOP
	DEFB $2D	;;duplicate		x,x.
	DEFB $E3	;;get-mem-3		x,x,guess
	DEFB $C4	;;st-mem-4		x,x,guess
	DEFB $05	;;div			x,x/guess.
	DEFB $E3	;;get-mem-3		x,x/guess,guess
	DEFB $0F	;;addition		x,x/guess+guess
	DEFB $A2	;;stk-half		x,x/guess+guess,.5
	DEFB $04	;;multiply		x,(x/guess+guess)*.5
	DEFB $C3	;;st-mem-3		x,newguess
	DEFB $E4	;;get-mem-4		x,newguess,oldguess
	DEFB $03	;;subtract		x,newguess-oldguess
	DEFB $27	;;abs			x,difference.

	DEFB $33	;;greater-0		x,(0/1).
	DEFB $00	;;jump-true		x.
	DEFB SLOOP-$	;;to sloop		x.

	DEFB $02	;;delete		.
	DEFB $E3	;;get-mem-3		retrieve final guess.
	DEFB $34	;;end-calc		sqr x.

	RET			; return with square root on stack

